]> arthur.barton.de Git - backup-script.git/blobdiff - bin/backup-script
Implement new "backup_type": "disabled"
[backup-script.git] / bin / backup-script
index e41e52b9ff0350441e4e33913b4f87d40c63dd39..b2a9b033751984ddaaf8e7e48a7fd6902d665c4f 100755 (executable)
@@ -1,7 +1,7 @@
 #!/bin/bash
 #
 # backup-script system for cloning systems using rsync
-# Copyright (c)2008-2015 Alexander Barton <alex@barton.de>
+# Copyright (c)2008-2016 Alexander Barton <alex@barton.de>
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,6 +15,7 @@ PIDFILE="/var/run/$NAME.pid"
 
 DRYRUN=0
 VERBOSE=0
+TAG=""
 
 export LC_ALL=C
 
@@ -22,6 +23,7 @@ declare -i count_all=0
 declare -i count_started=0
 declare -i count_ok=0
 declare -i count_ok_vanished=0
+declare -i count_enabled=0
 
 destinations=""
 
@@ -44,14 +46,17 @@ default_compress=1
 default_ping=1
 default_local=0
 default_generations=0
+default_io_timeout="1800"
 default_job_pre_exec=""
 default_job_post_exec=""
+default_tags=""
 
 Usage() {
        echo "Usage: $NAME [<options>] [<system> [<system> [...]]]"
        echo
-       echo "  -p, --progress    Show progress, see rsync(1)."
-       echo "  -n, --dry-run     Test run only, don't copy any data."
+       echo "  -n, --dry-run       Test run only, don't copy any data."
+       echo "  -p, --progress      Show progress, see rsync(1)."
+       echo "  -t TAG, --tag TAG   Only run jobs with tag TAG."
        echo
        echo "When no <system> is given, all defined systems are used."
        echo
@@ -278,6 +283,7 @@ done
 # Read in configuration file
 config_info="Configuration file is \"$conf\""
 if [ -r "$conf" ]; then
+       # shellcheck source=/dev/null
        source "$conf"
 else
        config_info="${config_info} (not readable, using defaults)"
@@ -292,6 +298,10 @@ while [ $# -gt 0 ]; do
          "-p"|"--progress")
                VERBOSE=1; shift
                ;;
+         "-t"|"--tag")
+               shift; TAG="$1"; shift
+               [ -n "$TAG" ] || Usage
+               ;;
          "-"*)
                Usage
                ;;
@@ -315,6 +325,8 @@ if [ $? -ne 0 ]; then
        exit 1
 fi
 echo "Rsync command is $rsync, protocol version $rsync_proto."
+
+[[ -n "$TAG" ]] && echo "Running jobs tagged with \"$TAG\"."
 echo
 
 trap GotSignal SIGINT
@@ -325,10 +337,10 @@ if [ $# -ge 1 ]; then
                        echo "$NAME: Can' read \"${conf_d}/$s\"!"
                        exit 3
                fi
-               sys="$sys ${conf_d}/$s"
+               sys+=("${conf_d}/$s")
        done
 else
-       sys="${conf_d}/"*
+       sys=("${conf_d}/"*)
 fi
 
 # check and create PID file
@@ -361,7 +373,7 @@ if [ -n "$pre_exec" ]; then
        echo
 fi
 
-for f in $sys; do
+for f in "${sys[@]}"; do
        [[ -r "$f" && -f "$f" ]] || continue
 
        fname=$(basename "$f")
@@ -388,6 +400,8 @@ for f in $sys; do
        generations="$default_generations"
        job_pre_exec="$default_job_pre_exec"
        job_post_exec="$default_job_post_exec"
+       tags="$default_tags"
+       io_timeout="$default_io_timeout"
 
        # Compatibility with backup-pull(1) script: Save global values ...
        pre_exec_saved="$pre_exec"
@@ -400,6 +414,7 @@ for f in $sys; do
        unset post_exec
 
        # Read in system configuration file
+       # shellcheck source=/dev/null
        source "$f"
 
        # Compatibility with backup-pull(1) script: Fix up configuration
@@ -423,12 +438,28 @@ for f in $sys; do
                compress=0
        fi
 
-       # Make sure "source" ends with a slash ("/")
-       case "$source" in
-         "*/")
+       # Add "NONE" tag when no tags are given in the config file:
+       [[ -z "$tags" ]] && tags="NONE"
+       # Add "auto-tags":
+       [[ "$local" -eq 1 ]] && tags="$tags,LOCAL"
+       # Check tags
+       if [[ -n "$TAG" && "$TAG" != "ALL" ]]; then
+               echo "$tags" | grep -E "(^|,)$TAG(,|$)" >/dev/null 2>&1
+               if [ $? -ne 0 ]; then
+                       if [ "$DRYRUN" -ne 0 ]; then
+                               echo "Tags of system \"$system\" don't match \"$TAG\": \"$tags\". Skipped."
+                               echo
+                       fi
+                       continue
+               fi
+       fi
+
+       # Make sure "source_root" ends with a slash ("/")
+       case "$source_root" in
+         *"/")
                ;;
-         "*")
-               source="$source/"
+         *)
+               source_root="$source_root/"
        esac
 
        # Make sure "target" DOESN'T end with a slash ("/")
@@ -447,6 +478,14 @@ for f in $sys; do
 
        count_all=$count_all+1
 
+       # Check if job is disabled
+       if [ "$backup_type" = "disabled" ]; then
+               echo "Job is DISABLED and will be skipped."
+               echo; continue
+       fi
+
+       count_enabled=$count_enabled+1
+
        # Check target directory
        if [ -z "$target" ]; then
                echo "No target directory specified for \"$system\"!? Skipped!"
@@ -543,10 +582,10 @@ for f in $sys; do
 
        # prepare (remote) command ...
        if [[ "$backup_type" == "rsync" ]]; then
-               cmd="$rsync --archive"
+               cmd="$rsync --archive --timeout=$io_timeout"
                [ "$compress" -ne 0 ] && cmd="$cmd --compress"
                [ "$local" -eq 0 ] && cmd="$cmd --rsh=\"$ssh_cmd\""
-               cmd="$cmd --delete --delete-excluded --sparse"
+               cmd="$cmd --delete-during --delete-excluded --sparse"
                if [ "$VERBOSE" -gt 0 ]; then
                        [ "$rsync_proto" -ge 31 ] \
                                && cmd="$cmd --info=progress2" \
@@ -708,7 +747,9 @@ CleanUp
 echo -n "Done: "; date
 echo
 [ $count_all -eq 1 ] && s="" || s="s"
-echo " - $count_all job$s defined,"
+[ $count_enabled -eq $count_all ] \
+       && echo " - $count_all job$s defined (all enabled)," \
+       || echo " - $count_all job$s defined ($count_enabled enabled),"
 [ $count_started -eq 1 ] && s="" || s="s"
 echo " - $count_started job$s started,"
 echo " - $count_ok done without errors."
@@ -718,7 +759,7 @@ if [ $count_started -ne $count_ok ]; then
        echo "----->  THERE HAVE BEEN ERRORS!  <-----"
        echo
        exit 6
-elif [ $count_all -ne $count_started ]; then
+elif [ $count_enabled -ne $count_started ]; then
        exit 7
 fi